<template>
    <q-dialog v-model="show" persistent>
      <q-card class="card">
        <q-card-section>
          <div class="text-h6">Actie</div>
        </q-card-section>
        <q-card-section>
          <q-select :rules="[val => !!val || 'Veld is verplicht!']"  v-model="actie.type" :options="options" label="Type" />
          <br>
          <q-input v-model="actie.omschrijving" label="Omschrijving" />
          <br>
         <q-input :rules="[val => !!val || 'Veld is verplicht!']"  filled v-model="actie.tijdstip">
      <template v-slot:prepend>
        <q-icon name="event" class="cursor-pointer">
          <q-popup-proxy transition-show="scale" transition-hide="scale">
            <q-date v-model="actie.tijdstip" mask="YYYY-MM-DD HH:mm" />
          </q-popup-proxy>
        </q-icon>
      </template>

      <template v-slot:append>
        <q-icon name="access_time" class="cursor-pointer">
          <q-popup-proxy transition-show="scale" transition-hide="scale">
            <q-time v-model="actie.tijdstip" mask="YYYY-MM-DD HH:mm" format24h />
          </q-popup-proxy>
        </q-icon>
      </template>
    </q-input>
          <br>
          <q-toggle
        v-model="actie.uitgevoerd"
        label="Uitgevoerd?"
        left-label
      />
        </q-card-section>
        <q-card-section v-show="banner">
              <q-banner inline-actions class="text-white bg-red">
      Vul de verplichte velden in!
      <template v-slot:action>
        <q-btn flat color="white" label="SLUIT" @click="banner = false" />
      </template>
    </q-banner>
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Annuleer" @click="$emit('hideDialog')" />
          <q-btn flat label="Voeg Toe" v-show="type == 'add'" @click="validate()" />
          <q-btn flat label="Update" v-show="type == 'edit'" @click="validate()" />
        </q-card-actions>
      </q-card>
    </q-dialog>
</template>

<style scoped>
.card {
min-width: 350px
}
</style>

<script>
export default {
  name: 'ActionDialog',
  data () {
    return {
      date: '',
      banner: false,
      options: [
        'Eten', 'Wassen', 'Omkeren'
      ]
    }
  },
  props: {
    show: Boolean,
    type: String,
    actie: [Object, Function]
  },
  methods: {
    cleanObject () {
      this.actie = {
        type: '',
        omschrijving: '',
        tijdstip: '',
        uitgevoerd: false,
        patientId: 0
      }
    },
    validate () {
      if (this.actie.type !== '' && this.actie.tijdstip !== '') {
        this.banner = false
        if (this.type === 'add') {
          this.$emit('addActie', this.actie)
        } else {
          this.$emit('editActie', this.actie)
        }
        this.$emit('hideDialog')
        this.cleanObject()
      } else {
        this.banner = true
      }
    }
  }
}

</script>
